Index: RTIA/TimeManagement.cc
===================================================================
RCS file: /sources/certi/certi/RTIA/TimeManagement.cc,v
retrieving revision 3.45
diff -u -r3.45 TimeManagement.cc
--- RTIA/TimeManagement.cc	18 Sep 2008 14:41:27 -0000	3.45
+++ RTIA/TimeManagement.cc	2 Apr 2009 19:56:31 -0000
@@ -18,7 +18,7 @@
 // along with this program ; if not, write to the Free Software
 // Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 //
-// $Id: TimeManagement.cc,v 3.45 2008/09/18 14:41:27 gotthardp Exp $
+// $Id: TimeManagement.cc,v 3.45.4.1 2009/01/05 13:34:49 gotthardp Exp $
 // ----------------------------------------------------------------------------
 
 #include <config.h>
@@ -107,11 +107,11 @@
 
         comm->sendMessage(&msg);
         lastNullMessageDate = heure_logique ;
-        D.Out(pdDebug, "NULL message sent (Time = %f).", heure_logique) ;
+        D.Out(pdDebug, "NULL message sent (Time = %f).", heure_logique.getTime()) ;
     }
     else {
         D.Out(pdExcept, "NULL message not sent (Time = %f, Last = %f).",
-              heure_logique, lastNullMessageDate);
+              heure_logique.getTime(), lastNullMessageDate.getTime());
     }
 }
 
@@ -497,11 +497,7 @@
 
         _type_granted_state = AFTER_TAR_OR_NER ;  // will be
 
-        // FIXME Erk-->Pierre 
-        // We were changing lookahead value to epsilon
-        // when doing zero lookahead I'd rather handle
-        // _any_ near-to-zero lookahead as ZERO_LK
-        if (0==RTIfedTime::fcmp(_lookahead_courant,0.0)) {           
+        if (_lookahead_courant == 0.0) {
            _type_granted_state = AFTER_TAR_OR_NER_WITH_ZERO_LK ;
         }
 
@@ -572,7 +568,7 @@
     else
         dateMNET = (_LBTS <= dateTSO ? _LBTS : dateTSO) ;
 
-   D.Out(pdRegister, "Minimum Next Event Time : %f.", dateMNET);
+   D.Out(pdRegister, "Minimum Next Event Time : %f.", dateMNET.getTime());
 
    return dateMNET ;
 }
@@ -597,7 +593,7 @@
         if (_est_regulateur)
             sendNullMessage(_heure_courante);
 
-        D.Out(pdRegister, "New Lookahead : %f.", _lookahead_courant);
+        D.Out(pdRegister, "New Lookahead : %f.", _lookahead_courant.getTime());
     }
 }
 
@@ -680,7 +676,7 @@
     // Modifier lookahead courant 
     _lookahead_courant = the_lookahead;
           D.Out(pdDebug,
-    	        "New lookahead = %f",_lookahead_courant);
+    	        "New lookahead = %f",_lookahead_courant.getTime());
     // faudrait peut etre remplacer heure courante par le temps en parametre      
         msg.setDate(_heure_courante + _lookahead_courant);
 
@@ -722,35 +718,23 @@
 bool
 TimeManagement::testValidTime(FederationTime theTime)
 {
-   int compareResult;
-   // FIXME Erk-->Pierre
-   // We should use RTIfedTime object and not _plain_ double
-   // value
    if (_avancee_en_cours == PAS_D_AVANCEE) {
       if (_type_granted_state == AFTER_TAR_OR_NER_WITH_ZERO_LK) {
-    	 compareResult = RTIfedTime::fcmp(theTime,_heure_courante);
-    	 // if theTime <= _heure_courante
-         if (compareResult==-1 || compareResult==0)
+         if (theTime <= _heure_courante)
             return false;
       }
       else {  // AFTER_TAR_OR_NER or AFTER_TARA_OR_NARA
-    	 compareResult = RTIfedTime::fcmp(theTime,_heure_courante + _lookahead_courant);
-    	 // if theTime  < _heure_courante + _lookahead_courant
-         if (compareResult == -1)
+         if (theTime  < _heure_courante + _lookahead_courant)
             return false;
       }
    }
    else {
       if (_type_granted_state == AFTER_TAR_OR_NER_WITH_ZERO_LK) {
-    	 compareResult = RTIfedTime::fcmp(theTime,date_avancee);
-    	 // if theTime <= date_avancee
-         if (compareResult==-1 || compareResult==0)
+         if (theTime <= date_avancee)
             return false;
       }
       else {  // AFTER_TAR_OR_NER or AFTER_TARA_OR_NARA
-    	 compareResult = RTIfedTime::fcmp(theTime,date_avancee + _lookahead_courant);
-    	 // if (theTime  < date_avancee + _lookahead_courant)
-         if (compareResult == -1)
+         if (theTime  < date_avancee + _lookahead_courant)
             return false;
       }
    }
@@ -838,9 +822,9 @@
     if (_est_contraint) {
         // give a TSO message.
         if (_LBTS == std::numeric_limits<double>::infinity())
-           D.Out(pdDebug, "Logical time : %f, LBTS : infini.", date_avancee);
+           D.Out(pdDebug, "Logical time : %f, LBTS : infini.", date_avancee.getTime());
         else
-           D.Out(pdDebug, "Logical time : %f, LBTS : %lf.", date_avancee, _LBTS);
+           D.Out(pdDebug, "Logical time : %f, LBTS : %lf.", date_avancee.getTime(), _LBTS.getTime());
         min = (_LBTS<date_avancee)?(_LBTS):(date_avancee);
         msg = queues->giveTsoMessage(min, msg_donne, msg_restant);
 
@@ -849,10 +833,10 @@
             // if LBTS allows to give a timeAdvanceGrant.
             if (_LBTS == std::numeric_limits<double>::infinity())
                D.Out(pdDebug, "Logical time : %f, LBTS : infini, lookahead : %f.",
-                     date_avancee, _lookahead_courant);
+                     date_avancee.getTime(), _lookahead_courant.getTime());
             else
                D.Out(pdDebug, "Logical time : %15.12f, LBTS : %15.12f, lookahead : %f.",
-                     date_avancee, _LBTS, _lookahead_courant);
+                     date_avancee.getTime(), _LBTS.getTime(), _lookahead_courant.getTime());
 
             if ((date_avancee < _LBTS) || 
                ((date_avancee == _LBTS) && (_avancee_en_cours == TARA))) {
@@ -895,7 +879,7 @@
     req.setFederationTime(logical_time);
 
     D.Out(pdRegister, "timeAdvanceGrant sent to federate (time = %f).",
-          req.getFederationTime());
+          req.getFederationTime().getTime());
 
     _tick_state = TICK_NEXT;  // indicate the callback was processed
 
@@ -920,15 +904,13 @@
     if (_avancee_en_cours != PAS_D_AVANCEE)
         e = e_TimeAdvanceAlreadyInProgress ;
 
-    /* logical_time <_heure_courante */
-    if (RTIfedTime::fcmp(logical_time ,_heure_courante) < 0)
+    if (logical_time < _heure_courante)
         e = e_FederationTimeAlreadyPassed ;
     
-    /* logical_time < _heure_courante + _lookahead_courant */
-    if (RTIfedTime::fcmp(logical_time , _heure_courante + _lookahead_courant)<0) {
+    if (logical_time < _heure_courante + _lookahead_courant) {
     	
     D.Out(pdDebug,"InvalidFederation time lkahead=%f, current=%f, requested=%f",
-    			_lookahead_courant,_heure_courante,logical_time);
+    			_lookahead_courant.getTime(),_heure_courante.getTime(),logical_time.getTime());
        e = e_InvalidFederationTime ;
     }
 
@@ -936,11 +918,7 @@
 
         _type_granted_state = AFTER_TAR_OR_NER ;  // will be
 
-        // FIXME Erk-->Pierre 
-        // We were changing lookahead value to epsilon
-        // when doing zero lookahead I'd rather handle
-        // _any_ near-to-zero lookahead as ZERO_LK
-        if (0==RTIfedTime::fcmp(_lookahead_courant,0.0)) {         
+        if (_lookahead_courant == 0.0) {         
            _type_granted_state = AFTER_TAR_OR_NER_WITH_ZERO_LK ;
         }
 
@@ -951,7 +929,7 @@
         date_avancee = logical_time ;
 
         D.Out(pdTrace, "timeAdvanceRequest accepted (asked time=%f).",
-              date_avancee);
+              date_avancee.getTime());
     }
     else {
         D.Out(pdExcept, "timeAdvanceRequest refused (exception = %d).", e);
@@ -987,7 +965,7 @@
         date_avancee = logical_time ;
 
         D.Out(pdTrace, "timeAdvanceRequestAvailable accepted (asked time=%f).",
-              date_avancee);
+              date_avancee.getTime());
     }
     else {
         D.Out(pdExcept, "timeAdvanceRequestAvailable refused (exception = %d).", e);
@@ -997,4 +975,4 @@
 
 }} // namespaces
 
-// $Id: TimeManagement.cc,v 3.45 2008/09/18 14:41:27 gotthardp Exp $
+// $Id: TimeManagement.cc,v 3.45.4.1 2009/01/05 13:34:49 gotthardp Exp $
Index: RTIA/RTIA_network.cc
===================================================================
RCS file: /sources/certi/certi/RTIA/RTIA_network.cc,v
retrieving revision 3.30
diff -u -r3.30 RTIA_network.cc
--- RTIA/RTIA_network.cc	20 Nov 2008 18:21:55 -0000	3.30
+++ RTIA/RTIA_network.cc	2 Apr 2009 19:56:31 -0000
@@ -18,7 +18,7 @@
 // along with this program ; if not, write to the Free Software
 // Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 //
-// $Id: RTIA_network.cc,v 3.30 2008/11/20 18:21:55 approx Exp $
+// $Id: RTIA_network.cc,v 3.30.4.1 2009/01/05 13:34:49 gotthardp Exp $
 // ----------------------------------------------------------------------------
 
 #include <config.h>
@@ -52,7 +52,7 @@
       {
           D.Out(pdTrace,
                 "Receving Message from RTIG, type NetworkMessage::MESSAGE_NULL(%f).",
-                msg->getDate());
+                msg->getDate().getTime());
 
           tm->update(msg->federate, msg->getDate());
           delete msg ;
@@ -368,4 +368,4 @@
 
 }} // namespace certi/rtia
 
-// $Id: RTIA_network.cc,v 3.30 2008/11/20 18:21:55 approx Exp $
+// $Id: RTIA_network.cc,v 3.30.4.1 2009/01/05 13:34:49 gotthardp Exp $
Index: include/RTI.hh
===================================================================
RCS file: /sources/certi/certi/include/RTI.hh,v
retrieving revision 3.15
diff -u -r3.15 RTI.hh
--- include/RTI.hh	10 Dec 2008 17:42:43 -0000	3.15
+++ include/RTI.hh	2 Apr 2009 19:56:32 -0000
@@ -16,14 +16,14 @@
 	#else
 		#define RTI_EXPORT __declspec(dllimport)
 	#endif
-    #if !defined(FEDTIME_EXPORT)
-       #define FEDTIME_EXPORT
+    #if defined(FedTime_EXPORTS)
+        #define FEDTIME_EXPORT __declspec(dllexport)
+    #else
+        #define FEDTIME_EXPORT __declspec(dllimport)
     #endif
 #else
 	#define RTI_EXPORT
-    #if !defined(FEDTIME_EXPORT)
-        #define FEDTIME_EXPORT
-    #endif
+    #define FEDTIME_EXPORT
 #endif
 
 #ifdef RTI_USES_STD_FSTREAM
Index: include/certi.hh
===================================================================
RCS file: /sources/certi/certi/include/certi.hh,v
retrieving revision 3.39
diff -u -r3.39 certi.hh
--- include/certi.hh	18 Dec 2008 19:45:47 -0000	3.39
+++ include/certi.hh	2 Apr 2009 19:56:32 -0000
@@ -102,30 +102,29 @@
 
 namespace certi {
 
-// RTI Shortcuts
-typedef RTI::AttributeHandle AttributeHandle ;
-typedef RTI::DimensionHandle DimensionHandle ;
-typedef RTI::EventRetractionHandle EventRetractionHandle ;
-typedef RTI::ExtentIndex ExtentIndex ;
-typedef RTI::FederateHandle FederateHandle ;
-typedef RTI::Handle Handle ;
-typedef RTI::InteractionClassHandle InteractionClassHandle ;
-typedef RTI::ObjectClassHandle ObjectClassHandle ;
-typedef RTI::ObjectHandle ObjectHandle ;
-typedef RTI::OrderType OrderType ;
-typedef RTI::ParameterHandle ParameterHandle ;
-typedef RTI::SpaceHandle SpaceHandle ;
-typedef RTI::TransportType TransportType ;
-typedef RTI::ULong ULong ;
-typedef RTI::UShort UShort ;
+typedef unsigned short UShort;
+typedef unsigned long ULong;
+typedef long Long;
+typedef ULong Handle;
+typedef Handle ObjectClassHandle;
+typedef Handle InteractionClassHandle;
+typedef ULong ExtentIndex;
+typedef Handle AttributeHandle;
+typedef Handle ParameterHandle;
+typedef Handle ObjectHandle;
+typedef Handle DimensionHandle;
+typedef Handle FederateHandle;
+typedef Handle OrderType;
+typedef Long SpaceHandle;
+typedef Handle TransportType;
+
+typedef RTI::EventRetractionHandle EventRetractionHandle;
 
-typedef RTI::Double FederationTime ;
 typedef UShort ObjectHandlecount ;
 typedef std::string ObjectName_t ;
 typedef std::string AttributeValue_t;
 typedef std::string ParameterValue_t;
 
-typedef RTI::Double FederationTimeDelta ;
 enum ObjectRemovalReason {
     OUT_OF_REGION = 1,
     OBJECT_DELETED,
Index: include/baseTypes.hh
===================================================================
RCS file: /sources/certi/certi/include/baseTypes.hh,v
retrieving revision 3.13
diff -u -r3.13 baseTypes.hh
--- include/baseTypes.hh	7 Dec 2008 20:16:12 -0000	3.13
+++ include/baseTypes.hh	2 Apr 2009 19:56:32 -0000
@@ -35,10 +35,10 @@
 };
 
 #define RTI_EXCEPT(A) \
-class RTI_EXPORT A : public Exception { \
+class A : public Exception { \
 public: \
-    static const char *_ex ; \
-    static long type ; \
+    static RTI_EXPORT const char *_ex ; \
+    static RTI_EXPORT long type ; \
     A (const char *reason) : Exception(reason) { _name = #A ; this->displayMe();} \
     A (ULong serial, const char *reason = 0) \
         : Exception(serial, reason) { _name = #A ; this->displayMe(); } \
Index: include/fedtime.hh
===================================================================
RCS file: /sources/certi/certi/include/fedtime.hh,v
retrieving revision 3.12
diff -u -r3.12 fedtime.hh
--- include/fedtime.hh	10 Dec 2008 17:42:43 -0000	3.12
+++ include/fedtime.hh	2 Apr 2009 19:56:32 -0000
@@ -1,35 +1,16 @@
 // HLA 1.3 Header "fedtime.hh"
-// $Id: fedtime.hh,v 3.12 2008/12/10 17:42:43 gotthardp Exp $
+// $Id: fedtime.hh,v 3.12.4.1 2009/01/05 13:34:50 gotthardp Exp $
 
 #ifndef HLA_FEDTIME_HH
 #define HLA_FEDTIME_HH
 
-#ifdef _WIN32
-#include <windows.h>
-#else
+#include "RTI.hh"
 #include <sys/types.h>
 #include <string.h>
-#endif
-
-#if defined(_WIN32)
-    #if defined(FedTime_EXPORTS)
-        #define FEDTIME_EXPORT __declspec(dllexport)
-    #else
-        #define FEDTIME_EXPORT __declspec(dllimport)
-    #endif
-#else
-	#define FEDTIME_EXPORT
-#endif
-
-#include "RTI.hh"
 
 class FEDTIME_EXPORT RTIfedTime : public RTI::FedTime
 {
 public:
-
-	static const double epsilon;
-	static int fcmp(const double x1, const double x2);
-
     RTIfedTime();
     RTIfedTime(const RTI::Double &);
     RTIfedTime(const RTI::FedTime &);
@@ -146,4 +127,4 @@
 
 #endif // HLA_FEDTIME_HH
 
-// $Id: fedtime.hh,v 3.12 2008/12/10 17:42:43 gotthardp Exp $
+// $Id: fedtime.hh,v 3.12.4.1 2009/01/05 13:34:50 gotthardp Exp $
Index: include/RTItypes.hh
===================================================================
RCS file: /sources/certi/certi/include/RTItypes.hh,v
retrieving revision 3.19
diff -u -r3.19 RTItypes.hh
--- include/RTItypes.hh	10 Dec 2008 16:53:24 -0000	3.19
+++ include/RTItypes.hh	2 Apr 2009 19:56:32 -0000
@@ -330,7 +330,7 @@
 	throw (ArrayIndexOutOfBounds) = 0 ;
 } ;
 
-class RTI_EXPORT FedTime
+class FEDTIME_EXPORT FedTime
 {
 public:
     virtual ~FedTime(){};
Index: libHLA/HLAbuffer.hh
===================================================================
RCS file: /sources/certi/certi/libHLA/HLAbuffer.hh,v
retrieving revision 1.8
diff -u -r1.8 HLAbuffer.hh
--- libHLA/HLAbuffer.hh	18 Dec 2008 19:45:47 -0000	1.8
+++ libHLA/HLAbuffer.hh	2 Apr 2009 19:56:32 -0000
@@ -48,7 +48,7 @@
 
 namespace libhla {
 
-std::ostream& __print_buffer(std::ostream& stream, const void *buffer, size_t length);
+HLA_EXPORT std::ostream& __print_buffer(std::ostream& stream, const void *buffer, size_t length);
 
 /* Caution:
  * This implementation assumes that there are no compiler-generated data in
Index: libRTI/RTIfedTime.cc
===================================================================
RCS file: libRTI/RTIfedTime.cc
diff -N libRTI/RTIfedTime.cc
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ libRTI/RTIfedTime.cc	1 Jan 1970 00:00:00 -0000
@@ -0,0 +1,501 @@
+// ----------------------------------------------------------------------------
+// CERTI - HLA RunTime Infrastructure
+// Copyright (C) 2002-2006  ONERA
+//
+// This file is part of CERTI-libCERTI
+//
+// CERTI-libCERTI is free software ; you can redistribute it and/or
+// modify it under the terms of the GNU Lesser General Public License
+// as published by the Free Software Foundation ; either version 2 of
+// the License, or (at your option) any later version.
+//
+// CERTI-libCERTI is distributed in the hope that it will be useful, but
+// WITHOUT ANY WARRANTY ; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+// Lesser General Public License for more details.
+//
+// You should have received a copy of the GNU Lesser General Public
+// License along with this program ; if not, write to the Free Software
+// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+// ----------------------------------------------------------------------------
+
+#include <math.h>
+
+#include "certi.hh"
+#include "fedtime.hh"
+#include "FedTimeD.hh"
+
+#include <algorithm>
+#include <limits>
+#include <sstream>
+#include <typeinfo>
+
+using std::stringstream ;
+
+namespace
+{
+
+// ----------------------------------------------------------------------------
+/** FedTime to RTIfedTime reference cast
+ */
+inline const RTIfedTime &
+rft(const RTI::FedTime &time)
+    throw (RTI::InvalidFederationTime)
+{
+    try {
+	return dynamic_cast<const RTIfedTime &>(time);
+    }
+    catch (std::bad_cast) {
+	//throw RTI::InvalidFederationTime("Could not cast to RTIfedTime");
+    }
+}
+
+inline bool
+is_infinity(const RTI::FedTime &time)
+{
+    return const_cast<RTI::FedTime &>(time).isPositiveInfinity() == RTI::RTI_TRUE ;
+}
+
+const char *infinity_str = "+inf" ;
+
+} // anonymous namespace
+
+// ----------------------------------------------------------------------------
+// FedTimeFactory
+RTI::FedTime *
+RTI::FedTimeFactory::makeZero()
+    throw (RTI::MemoryExhausted)
+{
+    try {
+        return new RTIfedTime();
+    }
+    catch (std::bad_alloc) {		
+        //throw RTI::MemoryExhausted("Cannot allocate RTI::FedTime.");
+    }
+}
+
+RTI::FedTime *
+RTI::FedTimeFactory::decode(const char *buf)
+    throw (RTI::MemoryExhausted)
+{
+    try {
+        return new RTIfedTime(*(const RTI::Double*)buf);
+    }
+    catch (std::bad_alloc) {
+        //throw RTI::MemoryExhausted("Cannot allocate RTI::FedTime.");
+    }
+}
+
+// ----------------------------------------------------------------------------
+// RTIfedTime
+RTIfedTime::RTIfedTime()
+    : _fedTime(0),
+      _zero(0),
+      _epsilon(std::numeric_limits<double>::epsilon()),
+      _positiveInfinity(std::numeric_limits<double>::infinity()) { }
+
+RTIfedTime::RTIfedTime(const RTI::Double &time)
+    : _fedTime(time),
+      _zero(0),
+      _epsilon(std::numeric_limits<double>::epsilon()),
+      _positiveInfinity(std::numeric_limits<double>::infinity()) { }
+
+RTIfedTime::RTIfedTime(const RTI::FedTime &time)
+    : _fedTime(rft(time).getTime()),
+      _zero(0),
+      _epsilon(std::numeric_limits<double>::epsilon()),
+      _positiveInfinity(std::numeric_limits<double>::infinity()) { }
+
+// ----------------------------------------------------------------------------
+RTIfedTime::RTIfedTime(const RTIfedTime &time)
+    : FedTime(),
+      _fedTime(time._fedTime),
+      _zero(time._zero),
+      _epsilon(time._epsilon),
+      _positiveInfinity(time._positiveInfinity) { }
+
+// ----------------------------------------------------------------------------
+RTIfedTime::~RTIfedTime()
+{
+}
+
+// ----------------------------------------------------------------------------
+void
+RTIfedTime::setZero()
+{
+    _fedTime = _zero;
+}
+
+// ----------------------------------------------------------------------------
+RTI::Boolean
+RTIfedTime::isZero()
+{
+    return RTI::Boolean(_fedTime == _zero);
+}
+
+// ----------------------------------------------------------------------------
+void
+RTIfedTime::setEpsilon()
+{
+    _fedTime = _epsilon;
+}
+
+// ----------------------------------------------------------------------------
+void
+RTIfedTime::setPositiveInfinity()
+{
+    _fedTime = _positiveInfinity;
+}
+
+// ----------------------------------------------------------------------------
+RTI::Boolean
+RTIfedTime::isPositiveInfinity()
+{
+    return RTI::Boolean(_fedTime == _positiveInfinity);
+}
+
+// ----------------------------------------------------------------------------
+int
+RTIfedTime::encodedLength() const
+{
+	// current implementation of RTIfedtime takes
+	// four IEEE-754 double values.
+	return (sizeof(_fedTime)+
+			sizeof(_zero)+
+			sizeof(_epsilon)+
+			sizeof(_positiveInfinity));
+}
+
+// ----------------------------------------------------------------------------
+void
+RTIfedTime::encode(char *buffer) const
+{
+    memcpy(buffer, &_fedTime, sizeof(RTI::Double));
+}
+
+// ----------------------------------------------------------------------------
+int
+RTIfedTime::getPrintableLength() const
+{
+    stringstream s ;
+
+    if (is_infinity(*this))
+	s << infinity_str ;
+    else
+	s << _fedTime ;
+
+    return s.str().length() + 1 ;
+}
+
+// ----------------------------------------------------------------------------
+void
+RTIfedTime::getPrintableString(char *str)
+{
+    stringstream s ;
+
+    if (is_infinity(*this))
+	s << infinity_str ;
+    else
+	s << _fedTime ;
+
+    s >> str ;
+    str[s.str().length()] = 0 ;
+}
+
+// ----------------------------------------------------------------------------
+RTI::FedTime &
+RTIfedTime::operator+=(const RTI::FedTime &time)
+    throw (RTI::InvalidFederationTime)
+{
+    _fedTime += rft(time)._fedTime ;
+    return *this;
+}
+
+// ----------------------------------------------------------------------------
+RTI::FedTime &
+RTIfedTime::operator-=(const RTI::FedTime &time)
+    throw (RTI::InvalidFederationTime)
+{
+    _fedTime -= rft(time)._fedTime ;
+    return *this;
+}
+
+// ----------------------------------------------------------------------------
+RTI::Boolean
+RTIfedTime::operator<=(const RTI::FedTime &time) const
+    throw (RTI::InvalidFederationTime)
+{
+    if (const_cast<RTI::FedTime &>(time).isPositiveInfinity())
+	return RTI::RTI_TRUE ;
+    else if (is_infinity(*this))
+	return RTI::RTI_FALSE ;
+    else
+	return RTI::Boolean(certi::fcmp(_fedTime, rft(time)._fedTime, _epsilon) <= 0);
+}
+
+// ----------------------------------------------------------------------------
+RTI::Boolean
+RTIfedTime::operator<(const RTI::FedTime &time) const
+    throw (RTI::InvalidFederationTime)
+{
+    if (is_infinity(*this))
+	return RTI::RTI_FALSE ;
+    else
+	return RTI::Boolean(is_infinity(time) || certi::fcmp(_fedTime, rft(time)._fedTime, _epsilon) < 0);
+}
+
+// ----------------------------------------------------------------------------
+RTI::Boolean
+RTIfedTime::operator>=(const RTI::FedTime &time) const
+    throw (RTI::InvalidFederationTime)
+{
+    if (is_infinity(*this))
+	return RTI::RTI_TRUE ;
+    else if (is_infinity(time))
+	return RTI::RTI_FALSE ;
+    else
+	return RTI::Boolean(certi::fcmp(_fedTime, rft(time)._fedTime, _epsilon) >= 0);
+}
+
+// ----------------------------------------------------------------------------
+RTI::Boolean
+RTIfedTime::operator>(const RTI::FedTime &time) const
+    throw (RTI::InvalidFederationTime)
+{
+    if (is_infinity(time))
+	return RTI::RTI_FALSE ;
+    else
+	return RTI::Boolean(is_infinity(*this) || certi::fcmp(_fedTime, rft(time)._fedTime, _epsilon) > 0);
+}
+
+// ----------------------------------------------------------------------------
+inline RTI::Boolean
+RTIfedTime::operator==(const RTI::FedTime &time) const
+    throw (RTI::InvalidFederationTime)
+{
+    if (is_infinity(*this) && is_infinity(time))
+	return RTI::RTI_TRUE ;
+    else if (is_infinity(*this) || is_infinity(time))
+	return RTI::RTI_FALSE ;
+    else
+	return RTI::Boolean(certi::fcmp(_fedTime, rft(time)._fedTime, _epsilon) == 0);
+}
+
+// ----------------------------------------------------------------------------
+RTI::FedTime &
+RTIfedTime::operator=(const RTI::FedTime &time)
+    throw (RTI::InvalidFederationTime)
+{
+    _fedTime = rft(time)._fedTime ;
+    return *this ;
+}
+
+// ----------------------------------------------------------------------------
+RTI::Double
+RTIfedTime::getTime() const
+{
+    return _fedTime ;
+}
+
+// ----------------------------------------------------------------------------
+RTI::Boolean
+RTIfedTime::operator==(const RTI::Double &time) const
+    throw (RTI::InvalidFederationTime)
+{
+    return RTI::Boolean(!is_infinity(*this) && certi::fcmp(_fedTime, time, _epsilon) == 0);
+}
+
+// ----------------------------------------------------------------------------
+RTI::Boolean
+RTIfedTime::operator!=(const RTI::FedTime &time) const
+    throw (RTI::InvalidFederationTime)
+{
+    return RTI::Boolean(certi::fcmp(_fedTime, rft(time)._fedTime, _epsilon) != 0);
+}
+
+// ----------------------------------------------------------------------------
+RTI::Boolean
+RTIfedTime::operator!=(const RTI::Double &time) const
+    throw (RTI::InvalidFederationTime)
+{
+    return RTI::Boolean(is_infinity(*this) || certi::fcmp(_fedTime, time, _epsilon) != 0);
+}
+
+// ----------------------------------------------------------------------------
+RTI::FedTime &
+RTIfedTime::operator=(const RTIfedTime &time)
+    throw (RTI::InvalidFederationTime)
+{
+    _fedTime = time._fedTime ;
+    return *this ;
+}
+
+// ----------------------------------------------------------------------------
+RTI::FedTime &
+RTIfedTime::operator=(const RTI::Double &time)
+    throw (RTI::InvalidFederationTime)
+{
+    _fedTime = time ;
+    return *this ;
+}
+
+RTI::FedTime &
+RTIfedTime::operator*=(const RTI::FedTime &time)
+    throw (RTI::InvalidFederationTime)
+{
+    _fedTime *= rft(time)._fedTime ;
+    return *this ;
+}
+
+RTI::FedTime &
+RTIfedTime::operator/=(const RTI::FedTime &time)
+    throw (RTI::InvalidFederationTime)
+{
+    _fedTime /= rft(time)._fedTime ;
+    return *this ;
+}
+
+RTI::FedTime &
+RTIfedTime::operator+=(const RTI::Double &time)
+    throw (RTI::InvalidFederationTime)
+{
+    _fedTime += time ;
+    return *this ;
+}
+
+RTI::FedTime &
+RTIfedTime::operator-=(const RTI::Double &time)
+    throw (RTI::InvalidFederationTime)
+{
+    _fedTime -= time ;
+    return *this ;
+}
+
+RTI::FedTime &
+RTIfedTime::operator*=(const RTI::Double &time)
+    throw (RTI::InvalidFederationTime)
+{
+    _fedTime *= time ;
+    return *this ;
+}
+
+RTI::FedTime &
+RTIfedTime::operator/=(const RTI::Double &time)
+    throw (RTI::InvalidFederationTime)
+{
+    _fedTime /= time ;
+    return *this ;
+}
+
+// ----------------------------------------------------------------------------
+RTIfedTime
+RTIfedTime::operator+(const RTI::FedTime &time)
+    throw (RTI::InvalidFederationTime)
+{
+    RTIfedTime fedtime = _fedTime + rft(time)._fedTime ;
+    return fedtime ;
+}
+
+RTIfedTime
+RTIfedTime::operator+(const RTI::Double &time)
+    throw (RTI::InvalidFederationTime)
+{
+    RTIfedTime fedtime = _fedTime + time ;
+    return fedtime ;
+}
+
+// ----------------------------------------------------------------------------
+RTIfedTime
+RTIfedTime::operator-(const RTI::FedTime &time)
+    throw (RTI::InvalidFederationTime)
+{
+    RTIfedTime fedtime = _fedTime - rft(time)._fedTime ;
+    return fedtime ;
+}
+
+RTIfedTime
+RTIfedTime::operator-(const RTI::Double &time)
+    throw (RTI::InvalidFederationTime)
+{
+    RTIfedTime fedtime = _fedTime - time ;
+    return fedtime ;
+}
+
+// ----------------------------------------------------------------------------
+RTIfedTime
+RTIfedTime::operator*(const RTI::FedTime &time)
+    throw (RTI::InvalidFederationTime)
+{
+    RTIfedTime fedtime = _fedTime * rft(time)._fedTime ;
+    return fedtime ;
+}
+
+RTIfedTime
+RTIfedTime::operator*(const RTI::Double &time)
+    throw (RTI::InvalidFederationTime)
+{
+    RTIfedTime fedtime = _fedTime * time ;
+    return fedtime ;
+}
+
+// ----------------------------------------------------------------------------
+RTIfedTime
+RTIfedTime::operator/(const RTI::FedTime &time)
+    throw (RTI::InvalidFederationTime)
+{
+    RTIfedTime fedtime = _fedTime / rft(time)._fedTime ;
+    return fedtime ;
+}
+
+RTIfedTime
+RTIfedTime::operator/(const RTI::Double &time)
+    throw (RTI::InvalidFederationTime)
+{
+    RTIfedTime fedtime = _fedTime / time ;
+    return fedtime ;
+}
+
+// ----------------------------------------------------------------------------
+std::ostream &
+operator<<(std::ostream &s, const RTI::FedTime &time)
+{
+    if (is_infinity(time))
+	s << infinity_str ;
+    else
+	s << rft(time).getTime();
+    return s ;
+}
+
+// ============================================================================
+
+// ----------------------------------------------------------------------------
+RTIfedTime
+operator+(const RTI::Double &d, const RTI::FedTime &time)
+{
+    RTIfedTime fedtime = d + rft(time).getTime();
+    return fedtime ;
+}
+
+// ----------------------------------------------------------------------------
+RTIfedTime
+operator-(const RTI::Double &d, const RTI::FedTime &time)
+{
+    RTIfedTime fedtime = d - rft(time).getTime();
+    return fedtime ;
+}
+
+// ----------------------------------------------------------------------------
+RTIfedTime
+operator*(const RTI::Double &d, const RTI::FedTime &time)
+{
+    RTIfedTime fedtime = d * rft(time).getTime();
+    return fedtime ;
+}
+
+// ----------------------------------------------------------------------------
+RTIfedTime
+operator/(const RTI::Double &d, const RTI::FedTime &time)
+{
+    RTIfedTime fedtime = d / rft(time).getTime();
+    return fedtime ;
+}
